// BongoEventWatcher.h: interface for the CBongoEventWatcher class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_BONGOEVENTWATCHER_H__8981823D_CD05_478B_BA82_45DDA344648C__INCLUDED_)
#define AFX_BONGOEVENTWATCHER_H__8981823D_CD05_478B_BA82_45DDA344648C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "IBongoEventWatcher.h"

class BO_SDK_API_EXP CBongoEventWatcher	: public IBongoEventWatcher
{
public:
	CBongoEventWatcher();
	virtual ~CBongoEventWatcher();

public:
	virtual bool	IsEnabled();

	virtual void OnBongoSettingsChanged();

	virtual void OnBongoObjectAnimationChanged( UUID uuidObject );

	virtual void OnBongoViewAnimationChanged( const WCHAR* wszName );

	virtual void OnSliderPositionChanged( double dOldPos, double dNewPos );

	virtual void OnRenderAnimationWillStart(int iCommandStyle);

	virtual void OnRenderAnimationCanceled(const WCHAR* wszOutputFile);

	virtual void OnAnimationFrameWritten( const WCHAR* wszFileName, int iFrameNumber, 
		double dTimelinePosition );

	virtual void OnRenderAnimationFinished(const WCHAR* wszOutputFile);

	virtual void OnEncodingWillStart( const WCHAR* wszFirstFileInSequence, const WCHAR* wszOutputFile,
		int iSpeedInFPS, int iStartFrame, int iStopFrame ); 

	virtual void OnAnimationModeChanged( BOOL bAnimationMode );

	virtual void OnPreviewStarted();
	virtual void OnPreviewStopped();

	virtual void OnPreviewPaused();

	virtual void OnTimelineTicksChanged();

	virtual void OnContextMenuDisplay(HMENU hMenu, const CONTEXT_MENU_TYPE type,
		const CONTEXT_MENU_VARIANT* var,
		const int iCmdFirst, const int iCmdLast);

	virtual void OnContextMenuItemInvoke(const CONTEXT_MENU_TYPE type, const CONTEXT_MENU_VARIANT* var,
		const int iCmdCode, const int iCmdFirst);
};

#endif // !defined(AFX_BONGOEVENTWATCHER_H__8981823D_CD05_478B_BA82_45DDA344648C__INCLUDED_)
