// BongoVariant.h: interface for the CBongoVariant class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_BONGOVARIANT_H__8EB7BCF5_A288_448F_9D49_FB5FA5C9F23C__INCLUDED_)
#define AFX_BONGOVARIANT_H__8EB7BCF5_A288_448F_9D49_FB5FA5C9F23C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class __declspec(dllexport) CBongoVariant  
{
public:
	enum BOVARTYPE 
	{
			boVT_empty			= 0,
			boVT_null			= 1, 
			boVT_char			= 2,
			boVT_short			= 3,
			boVT_long			= 4,
			boVT_float			= 5,
			boVT_int			= 6,
			boVT_bool			= 11,   // Boolean; True=1, False=0.
			boVT_double			= 17,
			
			boVT_3_double_array	= 19,   // vector xyz 1 double per axis

			boVT_str			= 20,
			boVT_uuid			= 21,
	};
	
protected:

    BOVARTYPE   type;
	union
	{
		char        sVal;
        short       iVal;
        long        lVal;
		float       fVal;
        double      dVal;
        bool        bVal;
		double		aVal[3];
		wchar_t*	wszVal;
		UUID		uuidVal;
	};

public:
	CBongoVariant();
	CBongoVariant(char   v);
    CBongoVariant(short  v);
    CBongoVariant(long   v);
	CBongoVariant(int    v);
	CBongoVariant(float  v);
    CBongoVariant(double v);
	CBongoVariant(bool   v);
	CBongoVariant(ON_Color v);
	CBongoVariant(ON_3dVector v);
	CBongoVariant(ON_3dPoint v);
	CBongoVariant(const wchar_t* v);
	CBongoVariant(UUID v);
	
	char			GetChar( ) const;
	short			GetShort( ) const;
	long			GetLong( ) const;
	int				GetInt( ) const;
	float			GetFloat( ) const;
	double			GetDouble( ) const;
	bool			GetBool( ) const;
	ON_Color		GetColor( ) const;
	ON_3dVector		GetVector( ) const;
	ON_3dPoint		GetPoint( ) const;
	const wchar_t*	GetWideChar( ) const;
	UUID			GetUuid() const;

	void	SetValue( char v );
	void	SetValue( short v );
	void	SetValue( long v );
	void	SetValue( int v );
	void	SetValue( float v );
	void	SetValue( double v );
	void	SetValue( bool v );
	void	SetValue( ON_Color v );
	void	SetValue( ON_3dVector v );
	void	SetValue( ON_3dPoint v );
	void	SetValue(  const wchar_t* v );
	void    SetValue( UUID v );

	BOVARTYPE Type() const;
	
};

#endif // !defined(AFX_BONGOVARIANT_H__8EB7BCF5_A288_448F_9D49_FB5FA5C9F23C__INCLUDED_)
