// IBongoEventWatcher.h: interface for the IBongoEventWatcher class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_IBONGOEVENTWATCHER_H__4F7E0F42_8059_4AE1_8DB7_77295A54D9A8__INCLUDED_)
#define AFX_IBONGOEVENTWATCHER_H__4F7E0F42_8059_4AE1_8DB7_77295A54D9A8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class IBongoEventWatcher
{
public:
  enum CONTEXT_MENU_TYPE
  {
    animation_manager_root_item,
	animation_manager_object_item,
	animation_manager_view_item,
	timeline,
	timeline_object_keyframe,
	timeline_object_looping_marker,
	timeline_view_keyframe,
	timeline_animation_limits,
  };

  struct CONTEXT_MENU_VARIANT
  {
	UUID uuidVar;
	int iVar;
	double dVar;
	HWND hwndVar;
	CString sVar;
  };

public:
	virtual bool	IsEnabled() = 0;

	virtual void OnBongoSettingsChanged() = 0;

	virtual void OnBongoObjectAnimationChanged( UUID uuidObject ) = 0;

	virtual void OnBongoViewAnimationChanged( const WCHAR* wszName ) = 0;

	virtual void OnSliderPositionWillChange( double dOldPos, double dNewPos ) = 0;
	virtual void OnSliderPositionChanged( double dOldPos, double dNewPos ) = 0;

	virtual void OnRenderAnimationWillStart(int iCommandStyle) = 0;

	virtual void OnRenderAnimationFinished(const WCHAR* wszOutputFile) = 0;

	virtual void OnRenderAnimationCanceled(const WCHAR* wszOutputFile) = 0;

	virtual void OnAnimationFrameWritten( const WCHAR* wszFileName, int iFrameNumber, 
		double dTimelinePosition ) = 0;

	virtual void OnEncodingWillStart( const WCHAR* wszFirstFileInSequence, const WCHAR* wszOutputFile,
		int iSpeedInFPS, int iStartFrame, int iStopFrame ) = 0; 

	virtual void OnAnimationModeChanged( BOOL bAnimationMode ) = 0;

	virtual void OnPreviewStarted() = 0;
	virtual void OnPreviewStopped() = 0;

	virtual void OnPreviewPaused() = 0;

	virtual void OnTimelineTicksChanged() = 0;

	virtual void OnContextMenuDisplay(HMENU hMenu, const CONTEXT_MENU_TYPE type,
		const CONTEXT_MENU_VARIANT* pVar,
		const int iCmdFirst, const int iCmdLast) = 0;

	virtual void OnContextMenuItemInvoke(const CONTEXT_MENU_TYPE type, const CONTEXT_MENU_VARIANT* pVar,
		const int iCmdCode, const int iCmdFirst) = 0;
};

#endif // !defined(AFX_IBONGOEVENTWATCHER_H__4F7E0F42_8059_4AE1_8DB7_77295A54D9A8__INCLUDED_)
