// BBTDeleteViewKeyframeRangeCmd.cpp: implementation of the CBBTDeleteViewKeyframeRangeCmd class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "BBTApp.h"
#include "BBTDeleteViewKeyframeRangeCmd.h"
#include "bbtmain.h"

extern CBBTMain bbt;

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

static class CBBTDeleteViewKeyframeRangeCmd theBBTDeleteObjectKeyframeRangeCmd;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CBBTDeleteViewKeyframeRangeCmd::CBBTDeleteViewKeyframeRangeCmd()
{
	wcsncpy( m_wszLocalCommandName, ThePlugIn().LocalizedString(2), BBT_STRING_BUFFER);
}

CBBTDeleteViewKeyframeRangeCmd::~CBBTDeleteViewKeyframeRangeCmd()
{
	
}

UUID CBBTDeleteViewKeyframeRangeCmd::CommandUUID()
{
	// {52DBB28E-BDDA-4b92-A8A0-A1D42900A364}
	static const GUID uuidCommand = 
	{ 0x52dbb28e, 0xbdda, 0x4b92, { 0xa8, 0xa0, 0xa1, 0xd4, 0x29, 0x0, 0xa3, 0x64 } };

	return uuidCommand;
}
	
void CBBTDeleteViewKeyframeRangeCmd::DoHelp()
{
	
}

const wchar_t* CBBTDeleteViewKeyframeRangeCmd::EnglishCommandName()
{
	return L"BongoBonusDeleteViewKeyframeRange"; 
}

const wchar_t* CBBTDeleteViewKeyframeRangeCmd::LocalCommandName() const 
{ 
	return m_wszLocalCommandName;
}

CRhinoCommand::result CBBTDeleteViewKeyframeRangeCmd::RunBongoCommand( const CRhinoCommandContext& context )
{
	bbt.WakeUp();


	CBongo bo;
	WCHAR wsz_Prompt[BBT_STRING_BUFFER];
	wcsncpy(wsz_Prompt, bo.String(8001),BBT_STRING_BUFFER);

	CRhinoViewport* pViewport = &(RhinoApp().ActiveView()->Viewport());
	if(!pViewport)	return CRhinoCommand::failure;

	CBongoView* pBongoView = 0;
	if(!CBongoView::ViewObject(pBongoView, pViewport) || !pBongoView)
	{
		delete pBongoView;
		pBongoView = 0;
		return CRhinoCommand::failure;
	}

	if(!ValidateView(pBongoView))
	{
		delete pBongoView;
		pBongoView = 0;
		BBTMsgBox(ThePlugIn().LocalizedString(2050));
		return CRhinoCommand::failure;
	}

	int iFrom, iTo;
	if(!CommandLineInput(iFrom, iTo))
	{
		delete pBongoView;
		pBongoView = 0;
		return CRhinoCommand::cancel;
	}
	
	DeleteKeyframes(pBongoView, iFrom, iTo);

	delete pBongoView;

	// refesh scene
	CBongoDoc* pBongoDoc = 0;
	if(CBongoDoc::DocumentObject(pBongoDoc) && pBongoDoc)
	{
		pBongoDoc->RefreshTimeline();
		pBongoDoc->RefreshScene();
	}
	
	delete pBongoDoc;


	return CRhinoCommand::success;
}

bool CBBTDeleteViewKeyframeRangeCmd::ValidateView(CBongoView* pView)
{
	if(!pView || !pView->IsValid() || !pView->IsAnimated() || !pView->FirstKeyframe())
		return false;

	return true;
}

bool CBBTDeleteViewKeyframeRangeCmd::CommandLineInput(int& iFrom, int& iTo)
{
	if(!GetCommandLineInteger( 2150, iFrom,0,BONGO_MAX_TIMELINE_RANGE-1,0,true,true))
		return false;

	if(!GetCommandLineInteger( 2151, iTo,1,BONGO_MAX_TIMELINE_RANGE-1-iFrom,iFrom+1,true,true))
		return false;

	return true;
}

bool CBBTDeleteViewKeyframeRangeCmd::DeleteKeyframes(CBongoView* pBongoView, int iFrom, int iTo)
{
	if(!pBongoView)
		return false;

	for(int j=iFrom; j<=iTo; j++)
	{
		pBongoView->DeleteKeyframe((double)j,false);
	}

	return true;
}	
