#if !defined(AFX_BBTGRAPHICDISPLAYDLG_H__870F0E2D_4757_4E0C_BB1F_0F633972E71D__INCLUDED_)
#define AFX_BBTGRAPHICDISPLAYDLG_H__870F0E2D_4757_4E0C_BB1F_0F633972E71D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// BBTGraphicDisplayDlg.h : header file
//


#include "BBTRhinoEventWatcher.h"


class CLBPGraphDisplay;

/////////////////////////////////////////////////////////////////////////////
// CBBTGraphicDisplayDlg dialog

class CBBTGraphicDisplayDlg : public CRhinoDialog,
							  public CRhinoEventWatcher	 
{
public:
	enum transformation_mode
	{
		rotation_transformation		= 0,
		scaling_transformation		= 1,
		motion_transformation		= 2,
	};


// Construction
public:
	CBBTGraphicDisplayDlg(CWnd* pParent = NULL);   // standard constructor
	~CBBTGraphicDisplayDlg();
// Dialog Data
	//{{AFX_DATA(CBBTGraphicDisplayDlg)
	enum { IDD = IDD_GRAPHIC_DISPLAY };
	CComboBox	m_comboTransformationMode;
	CButton	m_ctrlGraphicPlaceHolder;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBBTGraphicDisplayDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void PreSubclassWindow();
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CBBTGraphicDisplayDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnSelchangeComboTransformationMode();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()


protected:
	void OnDeselectAllObjects(CRhinoDoc& doc,int count);
	void OnDeselectObject(CRhinoDoc& doc, const CRhinoObject& object);
	void OnDeselectObjects(CRhinoDoc& doc, const ON_SimpleArray<const CRhinoObject*>& objects);
	void OnSelectObject(CRhinoDoc& doc,const CRhinoObject& object);
	void OnSelectObjects(CRhinoDoc& doc,const ON_SimpleArray<const CRhinoObject*>& objects);
	void OnReplaceObject(CRhinoDoc& doc, CRhinoObject& old_object, CRhinoObject& new_object);
	void OnSelectionChanged();
		

public:
	void OnWindowClosed();

public:
	bool GetDirtyFlag();
	void SetDirtyFlag(bool b = true);

	void SetSkipNextSelectionChangedNotification(bool bFlag);

	void UpdateSliderPos(double dPos);

protected:
	bool PlaceGraphicDisplayOnDialog();
	bool InitializeTransformationModeComboBox();
	bool RefreshDisplay();

private:
	CLBPGraphDisplay* m_pGraphicDisplay;
	bool m_bDirtyFlag;
	bool m_bSkipNextSelectionChangeNotification;	// this is because OnSliderMoved will cause sel change.
	transformation_mode m_modeTransformation;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BBTGRAPHICDISPLAYDLG_H__870F0E2D_4757_4E0C_BB1F_0F633972E71D__INCLUDED_)
