// BBTMoveObjectKeyframeRangeCmd.h: interface for the CBBTMoveObjectKeyframeRangeCmd class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_BBTMOVEOBJECTKEYFRAMERANGECMD_H__BFCD3055_95DD_414F_81A5_0CB672EE90C9__INCLUDED_)
#define AFX_BBTMOVEOBJECTKEYFRAMERANGECMD_H__BFCD3055_95DD_414F_81A5_0CB672EE90C9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CBBTMoveObjectKeyframeRangeCmd  : public CBongoCommand
{
public:
	CBBTMoveObjectKeyframeRangeCmd();
	virtual ~CBBTMoveObjectKeyframeRangeCmd();

	UUID CommandUUID();

public:
	const wchar_t* EnglishCommandName();
	const wchar_t* LocalCommandName() const;
	CRhinoCommand::result RunBongoCommand( const CRhinoCommandContext& );
	virtual void DoHelp();

public:
	int CreateObjectData(CArray<const CRhinoObject*, const CRhinoObject*>& aObjects);
	void FlushObjects();
	bool MoveKeyframes(int iFrom, int iTo, int iRange);
	bool SetKeyframes();

protected:
	struct OBJECT_DATA
	{
		CBongoObject* pBongoObject;
		CArray<CBongoKeyframe*, CBongoKeyframe*> aKFs;
	};

protected:
	int CreateObjectData(CRhinoGetObject* pObjectSelection);
	bool CommandLineInput(int& iFrom, int& iTo, int& iRange);


private:
	WCHAR m_wszLocalCommandName[BBT_STRING_BUFFER];
	CArray<OBJECT_DATA*, OBJECT_DATA*> m_aObjects;
};

CBBTMoveObjectKeyframeRangeCmd& MoveObjectKeyframeRangeCmd();

#endif // !defined(AFX_BBTMOVEOBJECTKEYFRAMERANGECMD_H__BFCD3055_95DD_414F_81A5_0CB672EE90C9__INCLUDED_)
