// BBTMoveViewKeyframeRangeCmd.h: interface for the CBBTMoveViewKeyframeRangeCmd class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_BBTMOVEVIEWKEYFRAMERANGECMD_H__60D9E255_9E17_4ECC_9CCA_83FA65AA8E05__INCLUDED_)
#define AFX_BBTMOVEVIEWKEYFRAMERANGECMD_H__60D9E255_9E17_4ECC_9CCA_83FA65AA8E05__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CBBTMoveViewKeyframeRangeCmd : public CBongoCommand  
{
public:
	CBBTMoveViewKeyframeRangeCmd();
	virtual ~CBBTMoveViewKeyframeRangeCmd();

public:
	UUID CommandUUID();
	const wchar_t* EnglishCommandName();
	const wchar_t* LocalCommandName() const;
	CRhinoCommand::result RunBongoCommand( const CRhinoCommandContext& );
	virtual void DoHelp();

public:
	int CreateViewData(CArray<CRhinoViewport*, CRhinoViewport*>& aViews);
	bool MoveKeyframes(int iFrom, int iTo, int iRange);
	bool SetKeyframes();
	void Flush();

protected:
	struct VIEW_DATA
	{
		CRhinoViewport* pViewport;
		CArray<CBongoKeyframe*, CBongoKeyframe*> aKFs;
	};

protected:
	bool CommandLineInput(int& iFrom, int& iTo, int& iRange);

private:
	WCHAR m_wszLocalCommandName[BBT_STRING_BUFFER];
	CArray<VIEW_DATA*, VIEW_DATA*> m_aViews;
};

CBBTMoveViewKeyframeRangeCmd&	MoveViewKeyframeRangeCmd();

#endif // !defined(AFX_BBTMOVEVIEWKEYFRAMERANGECMD_H__60D9E255_9E17_4ECC_9CCA_83FA65AA8E05__INCLUDED_)
