// BBTRenderAnimationFileCollectionCmd.cpp: implementation of the CBBTRenderAnimationFileCollectionCmd class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "BBTApp.h"
#include "BBTRenderAnimationFileCollectionCmd.h"
#include "bbtmain.h"
#include "BBTRenderAnimationFileCollectionDlg.h"
#include "BBTEventWatcher.h"

extern CBBTMain bbt;
extern CBBTApp theApp;


static class CBBTRenderAnimationFileCollectionCmd theBBTRenderAnimationFileCollectionCmd;


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CBBTRenderAnimationFileCollectionCmd::CBBTRenderAnimationFileCollectionCmd()
{
	wcsncpy( m_wszLocalCommandName, ThePlugIn().LocalizedString(12), BBT_STRING_BUFFER);
}

CBBTRenderAnimationFileCollectionCmd::~CBBTRenderAnimationFileCollectionCmd()
{

}

UUID CBBTRenderAnimationFileCollectionCmd::CommandUUID()
{
	// {48F06B86-3D64-42ed-848B-E3162A3704E8}
	static const GUID uuidRenderAnimationFileCollection = 
	{ 0x48f06b86, 0x3d64, 0x42ed, { 0x84, 0x8b, 0xe3, 0x16, 0x2a, 0x37, 0x4, 0xe8 } };

	return uuidRenderAnimationFileCollection;
}
	
void CBBTRenderAnimationFileCollectionCmd::DoHelp()
{
	
}

const wchar_t* CBBTRenderAnimationFileCollectionCmd::EnglishCommandName()
{
	return L"BongoBonusRenderAnimationFileCollection"; 
}

const wchar_t* CBBTRenderAnimationFileCollectionCmd::LocalCommandName() const 
{ 
	return m_wszLocalCommandName;
}

CRhinoCommand::result CBBTRenderAnimationFileCollectionCmd::RunBongoCommand( const CRhinoCommandContext& context )
{
	bbt.WakeUp();

	CBBTRenderAnimationFileCollectionDLG  dlg;

	if(dlg.DoModal() != IDOK)
	{
		return CRhinoCommand::cancel;
	}

	if(dlg.FileCount() > 0)
	{

		CRhinoDoc* pDoc = RhinoApp().ActiveDoc();
		if(pDoc)
		{
			BOOL bIsModified = pDoc->IsModified();
			if(bIsModified)
			{
				pDoc->DoFileSave();
			}
		}

		SetTimer(0, BBT_RENDER_FILE_COLLECTION_TIMER, 1000, RenderFileCollectionTimer);	
	}

	return CRhinoCommand::success;
}