// BBTRenderAnimationFileCollectionDLG.cpp : implementation file
//

#include "stdafx.h"
#include "BBTApp.h"
#include "BBTRenderAnimationFileCollectionDLG.h"
#include "LBPRegistryWrapper.h"
#include "LBPSemicolonDelimitedString.h"
#include "bbtmain.h"

extern CBBTMain bbt;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBBTRenderAnimationFileCollectionDLG dialog


CBBTRenderAnimationFileCollectionDLG::CBBTRenderAnimationFileCollectionDLG(CWnd* pParent /*=NULL*/)
	: CDialog(CBBTRenderAnimationFileCollectionDLG::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBBTRenderAnimationFileCollectionDLG)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	m_iFileCount = 0;
}

CBBTRenderAnimationFileCollectionDLG::~CBBTRenderAnimationFileCollectionDLG()
{

}

void CBBTRenderAnimationFileCollectionDLG::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBBTRenderAnimationFileCollectionDLG)
	DDX_Control(pDX, IDC_LIST_FILES, m_listFiles);
	DDX_Control(pDX, IDC_BUTTON_LISTBUDDY, m_buttonListBuddy);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CBBTRenderAnimationFileCollectionDLG, CDialog)
	//{{AFX_MSG_MAP(CBBTRenderAnimationFileCollectionDLG)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBBTRenderAnimationFileCollectionDLG message handlers

BOOL CBBTRenderAnimationFileCollectionDLG::OnInitDialog() 
{
	CDialog::OnInitDialog();

	SendMessage(WM_SETICON, (WPARAM)ICON_SMALL, (LPARAM)bbt.BongoIcon());

	m_buttonListBuddy.SubclassDlgItem(IDC_BUTTON_LISTBUDDY, this);
    m_buttonListBuddy.SetListbox( &m_listFiles);
	
	ReadFromRegistry();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

bool CBBTRenderAnimationFileCollectionDLG::ReadFromRegistry()
{
	CString sFileList;

	CLBPRegistryWrapper wrap;
	if(!wrap.GetStringValue(HKEY_CURRENT_USER, BBT_REGPATH, "RenderAnimationFileCollection", sFileList))
		return false;

	if(!sFileList.IsEmpty())
	{

		CString sFile;

		CLBPSemicolonDelimitedString StringExtractor(sFileList);
		for(int i= 0; StringExtractor.GetItemByPosition(i, sFile); i++)
		{
			m_listFiles.InsertString(-1, sFile);
		}
	}

	return true;
}

bool CBBTRenderAnimationFileCollectionDLG::WriteToRegistry()
{
	CString sFile, sFileList;

	for (int i=0;i < m_listFiles.GetCount();i++)
	{
		m_listFiles.GetText(i, sFile);
		sFileList += sFile + ";";
	}

	if(!sFileList.IsEmpty())
	{
		CLBPSemicolonDelimitedString FullList(sFileList); 
		sFileList = FullList.GetString();

		CLBPRegistryWrapper wrap;
		if(!wrap.SetStringValue(HKEY_CURRENT_USER, BBT_REGPATH, "RenderAnimationFileCollection",
			sFileList))
			return false;
	}

	return true;
}

void CBBTRenderAnimationFileCollectionDLG::OnOK() 
{
	WriteToRegistry();
	
	m_iFileCount = m_listFiles.GetCount();

	CDialog::OnOK();
}


int CBBTRenderAnimationFileCollectionDLG::FileCount()
{
	return m_iFileCount;
}
